<template>
  <GManageTable
    :card="card"
    :level="level"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value[quantityKey]"
    use-wrapper
    :get-new-item="getNewItem"
    :optional="optional"
    :wiki-entry="wikiEntry"
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item, updateAvailableElements }">
      <Quantity
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
        :primitive="primitive"
      />
    </template>

    <template #[`item.name`]="{ item }">
      {{ getForCurrentLocale(item.name) }}
    </template>

    <template #[`item.value`]="{ item }">
      <div v-if="item.noQuantity && item.noQuantity.name">
        {{ getForCurrentLocale(item.noQuantity.name) }}
      </div>
      <div
        v-else-if="item.noQuantity && item.noQuantity.content"
        class="text-truncate default-max-width"
      >
        {{ getForCurrentLocale(item.noQuantity) }}
      </div>

      <div
        v-else-if="item.charsXMLList"
        class="text-truncate default-max-width"
      >
        {{ item.charsXMLList._text }}
      </div>
      <div
        v-for="(valueString, index) of getDisplayedUnitAndValue(item).values"
        v-else
        :key="index"
        class="text-truncate default-max-width"
      >
        {{ valueString }}<br />
      </div>
    </template>
    <template #[`item.unit`]="{ item }">
      <div v-if="item.noQuantity">(NoQuantity)</div>
      <div v-else-if="item.charsXMLList">(CharsXMLList)</div>
      <div v-else>
        {{ getDisplayedUnitAndValue(item).units.join("\n") }}
      </div>
    </template>
  </GManageTable>
</template>

<script>
import { QuantityType, PrimitiveQuantityType } from "@d-ptb/dcc-js";
import { removeFromArray } from "~/assets/util/general";
import { getDisplayedUnitAndValue } from "~/assets/util/dccUtil";
import Quantity from "~/components/DCC/Common/Quantity";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import { validatableMixin } from "~/components/Mixins/validatableMixin";

export default {
  name: "QuantityList",
  components: {
    Quantity,
    GManageTable,
  },
  mixins: [localizationMixin, validatableMixin],
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.tables.quantityList",
    },
    card: {
      type: Boolean,
      default: true,
    },
    level: String,
    optional: {
      type: Boolean,
      default: false,
    },
    quantityKey: {
      type: String,
      default: "quantity",
    },
    primitive: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
      default: "quantity",
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.attributes.refType"),
          value: "_attr.refType",
        },
        {
          text: this.$t("dcc.common.quantityType.name"),
          value: "name",
        },
        {
          text: this.$t("d_si.real.value"),
          value: "value",
        },
        {
          text: this.$t("d_si.real.unit"),
          value: "unit",
        },
      ],
    };
  },
  computed: {
    customRules() {
      return [
        () =>
          (this.value[this.quantityKey] &&
            this.value[this.quantityKey].length > 0) ||
          this.$t("dcc.tables.quantityList.empty"),
      ];
    },
  },
  watch: {
    value: {
      handler() {
        this.validate();
      },
      deep: true,
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value[this.quantityKey], item);
    },
    getNewItem() {
      return this.primitive ? new QuantityType() : new PrimitiveQuantityType();
    },
    create(item) {
      this.value[this.quantityKey].push(item);
    },
    edit(item, index) {
      this.validate();

      this.$set(this.value[this.quantityKey], index, undefined);
      this.$set(
        this.value[this.quantityKey],
        index,
        this.primitive
          ? new PrimitiveQuantityType(item)
          : new QuantityType(item)
      );
    },
    getDisplayedUnitAndValue,
  },
};
</script>
